VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Sample"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements ApplicationAddInServer
Private oApp As Inventor.Application
Private oCmd1 As Command
Private oCmd2 As Command

Private Sub ApplicationAddInServer_Activate(ByVal AddInSiteObject As Inventor.ApplicationAddInSite, ByVal FirstTime As Boolean)
    ' Save a reference to the Application object.
    Set oApp = AddInSiteObject.Application
    
    ' Create the first command.
    Set oCmd1 = AddInSiteObject.CreateCommand("Draw Slot", 1, True)
    
    ' Create the second command.
    Set oCmd2 = AddInSiteObject.CreateCommand("Toggle 1", 2, True)
End Sub

Private Property Get ApplicationAddInServer_Automation() As Inventor.AddInAutomation
'
End Property

Private Sub ApplicationAddInServer_Deactivate()
    ' Release all references.
    Set oCmd1 = Nothing
    Set oCmd2 = Nothing
    Set oApp = Nothing
End Sub

Private Sub ApplicationAddInServer_ExecuteCommand(ByVal CommandID As Long)
    ' Check to see which command was run.
    Select Case CommandID
        Case 1
            ' Check to make sure a sketch is active.
            If TypeOf oApp.ActiveEditObject Is PlanarSketch Then
                ' Call the method to draw the sketch.
                Call DrawSlot(oApp.ActiveEditObject)
            Else
                ' No sketch is active so display an error.
                MsgBox "A sketch must be active for this command."
            End If
        Case 2
            ' Toggle the enabled state of command 1.
            If oCmd1.Enabled Then
                oCmd1.Enabled = False
            Else
                oCmd1.Enabled = True
            End If
    End Select
End Sub

Private Sub DrawSlot(oSketch As PlanarSketch)
    Dim oLines(1 To 2) As SketchLine
    Dim oArcs(1 To 2) As SketchArc
    Dim oTransGeom As TransientGeometry
    
    ' Draw the lines and arcs that make up the shape of the slot.
    With oApp.TransientGeometry
        Set oLines(1) = oSketch.SketchLines.AddByTwoPoints( _
                    .CreatePoint2d(0, 0), .CreatePoint2d(5, 0))
        Set oArcs(1) = oSketch.SketchArcs.AddByCenterStartEndPoint( _
                    .CreatePoint2d(5, 1), oLines(1).EndSketchPoint, _
                    .CreatePoint2d(5, 2))
        Set oLines(2) = oSketch.SketchLines.AddByTwoPoints( _
                    oArcs(1).EndSketchPoint, .CreatePoint2d(0, 2))
        Set oArcs(2) = oSketch.SketchArcs.AddByCenterStartEndPoint( _
                    .CreatePoint2d(0, 1), oLines(2).EndSketchPoint, _
                    oLines(1).StartSketchPoint)
    End With
    
    ' Create the tangent constraints between the lines and arcs.
    Call oSketch.GeometricConstraints.AddTangent(oLines(1), oArcs(1))
    Call oSketch.GeometricConstraints.AddTangent(oLines(2), oArcs(1))
    Call oSketch.GeometricConstraints.AddTangent(oLines(2), oArcs(2))
    Call oSketch.GeometricConstraints.AddTangent(oLines(1), oArcs(2))
    
    ' Create a parallel constraint between the two lines.
    Call oSketch.GeometricConstraints.AddParallel(oLines(1), oLines(2))
End Sub


